
set echo on

DROP TABLE source_table;
DROP TABLE target_table;

CREATE TABLE source_table
NOLOGGING
AS
   SELECT ROWNUM AS object_id
   ,      object_name
   ,      object_type
   FROM   all_objects;

INSERT /*+ APPEND */ INTO source_table
SELECT ROWNUM + (COUNT(*) OVER () * 5) AS object_id
,      LOWER(object_name)              AS object_name
,      SUBSTR(object_type,1,1)         AS object_type
FROM   all_objects;

COMMIT;

INSERT /*+ APPEND */ INTO source_table
SELECT ROWNUM + (COUNT(*) OVER() * 10) AS object_id
,      INITCAP(object_name)            AS object_name
,      SUBSTR(object_type,-1)          AS object_type
FROM   all_objects;

COMMIT;

ALTER TABLE source_table ADD PRIMARY KEY (object_id);

CREATE TABLE target_table
NOLOGGING
AS
   SELECT *
   FROM   source_table SAMPLE (50);

ALTER TABLE target_table ADD PRIMARY KEY (object_id);

exec DBMS_STATS.GATHER_TABLE_STATS(user,'source_table',cascade=>true);
exec DBMS_STATS.GATHER_TABLE_STATS(user,'target_table',cascade=>true);

