
set echo on
set serveroutput on

DROP TRIGGER insert_trigger;
DROP TRIGGER update_trigger;

CREATE OR REPLACE TRIGGER merge_trigger
   AFTER MERGE 
   ON    target_table
BEGIN
   DBMS_OUTPUT.PUT_LINE('Merge trigger...');
END;
/

MERGE
   INTO  target_table tgt
   USING source_table src
   ON  ( src.object_id = tgt.object_id )
WHEN MATCHED 
THEN
   UPDATE
   SET   tgt.object_name = src.object_name
   ,     tgt.object_type = src.object_type
WHEN NOT MATCHED 
THEN
   INSERT ( tgt.object_id
          , tgt.object_name
          , tgt.object_type )
   VALUES ( src.object_id
          , src.object_name
          , src.object_type );

ROLLBACK;

