

set echo on

set timing on

DELETE FROM target_table;

SAVEPOINT x;

MERGE
   INTO  target_table tgt
   USING source_table src
   ON  ( src.object_id = tgt.object_id )
WHEN MATCHED 
THEN
   UPDATE
   SET   tgt.object_name = src.object_name
   ,     tgt.object_type = src.object_type
WHEN NOT MATCHED 
THEN
   INSERT ( tgt.object_id
          , tgt.object_name
          , tgt.object_type )
   VALUES ( src.object_id
          , src.object_name
          , src.object_type );

ROLLBACK TO SAVEPOINT x;

MERGE
   INTO  target_table tgt
   USING source_table src
   ON  ( src.object_id = tgt.object_id )
WHEN NOT MATCHED 
THEN
   INSERT ( tgt.object_id
          , tgt.object_name
          , tgt.object_type )
   VALUES ( src.object_id
          , src.object_name
          , src.object_type )
WHEN MATCHED 
THEN
   UPDATE
   SET   tgt.object_name = src.object_name
   ,     tgt.object_type = src.object_type;

set timing off
ROLLBACK;


