
set echo on

ALTER TABLE source_table DROP PRIMARY KEY;

INSERT INTO source_table
SELECT * 
FROM   target_table
WHERE  ROWNUM <= 10000;

MERGE
   INTO  target_table tgt
   USING source_table src
   ON  ( src.object_id = tgt.object_id )
WHEN MATCHED 
THEN
   UPDATE
   SET    tgt.object_type = src.object_type
   ,      tgt.object_name = src.object_name 
WHEN NOT MATCHED 
THEN
   INSERT ( tgt.object_id
          , tgt.object_name
          , tgt.object_type )
   VALUES ( src.object_id
          , src.object_name
          , src.object_type );

ROLLBACK;

