
set echo on
set serveroutput on

CREATE OR REPLACE TRIGGER insert_trigger
   AFTER INSERT 
   ON    target_table
BEGIN
   DBMS_OUTPUT.PUT_LINE('Insert trigger...');
END;
/

CREATE OR REPLACE TRIGGER update_trigger
   AFTER UPDATE 
   ON    target_table
BEGIN
   DBMS_OUTPUT.PUT_LINE('Update trigger...');
END;
/

MERGE
   INTO  target_table tgt
   USING source_table src
   ON  ( src.object_id = tgt.object_id )
WHEN MATCHED 
THEN
   UPDATE
   SET   tgt.object_name = src.object_name
   ,     tgt.object_type = src.object_type
WHEN NOT MATCHED 
THEN
   INSERT ( tgt.object_id
          , tgt.object_name
          , tgt.object_type )
   VALUES ( src.object_id
          , src.object_name
          , src.object_type );

ROLLBACK;

